;This is sample source for all you programmers out there who are intrested in learning some
; of the new things possible with this fantastic OS.  If you are pathetic then you can still
; use the stone tools and square wheels and program in the Ice Age the ZShell way.  You may
; compile any ZShell source with usgard.h (which replaces ti-85.h) and compile it with the
; new STRING85.  It will still work.  You just will not reap the rewards that comes with
; Usgard such as speed, great new functions, simplicity, and memory savings.  Suit yourself
; either way.
;So anyways, here is a program I made (I am Austin Butler, @u$+!N prgms) that involves a
; wicked bird and a stupid man.  Your mission, should you choose to accept it, is to empty
; your 'contents' onto the man's head.  Fun, very fun...  This program uses some of the neat
; functions created in Usgard.
;Have fun learning, programming, or whatever you want to do.  If you feel like lifting some
; of my source for your own use, please just tell me so I can see what becomes of it.  Thanks,
;
;@u$+!N                         
					;Usgard.h is the replacement for ti-85.h
#include "usgard.h"                     ;This how to call the functions of a library.
#include "spritlib.h"                   ;Each library has a header which defines
#include "winlib.h"                     ; all of it's functions.

birdpos = TEXT_MEM                      ;This is the x/y position for the bird.
manpos = TEXT_MEM+2                     ;X pos of man since his Y is constant.
pottypos = TEXT_MEM+3                   ;X/Y pos of the bird poop.
pottycheck = TEXT_MEM+5                 ;0 if potty in motion.
score = TEXT_MEM+6                      ;hold score.
.org 0                                  ;begin.
.db "Potty Pigeon V.3.0",0              ;title.  Just like ZShell.  For ZShell compatiblity
					; and stuff.
.db SPRITLIB,WINLIB,0                   ;This is NEW!  After the title, define which libs        
					; MUST be present for the program to run.  If the 
					; program can run without a certain lib, then do 
					; not include it here.
	ld      hl, GRAPH_MEM           ;Set where sprites will be put for later.
	LIB_CALL_(SPRITLIB,SET_DEST)    ;Call a library.  Libname,Function as defined
	xor     a
	ld      a, 4                    ;Doing the PUT_PIXEL thingy.
	ld      (pottycheck), a         ;Putting a non-zero number in pottycheck
	out     (5), a                  ; so it knows it is not going... potty.

	ld      a, 20                   ;Score counts downwards giving you 20 points
	ld      (score), a              ; until you lose.
	ld      bc, $0207               ;Beginning of first windows routine!
	ld      hl, $0C28               ;BC = X/Y   HL = X/Y length.
					;This R_ label adds (PROGRAM_ADDR) to the
R_begn: ld      ix, begintxt            ; next command.  That saves you from loading
					; (PROGRAM_ADDR) and adding it to hl.  It
					; saves memory and speeds it up.  The new
					; STRING85.EXE does it.
	
	ld      de, (PROGRAM_ADDR)      ;Loading the title from the beginning.
	ld      a, %111                  ;IX = window contents   DE = title text.
					;A = status byte
					; set bit 0 to display contents
					; set bit 1 to display title text
	LIB_CALL_(WINLIB,WIN_PSHOW)     ;Calling function to prepare & show Window.
	ld      bc, $0B0E               ;Setting up second window.  The little one.
	ld      hl, $0321
R_bg1:  ld      ix, sizetxt             ;Loading sizes for the choice menu.
R_bg2:  ld      de, sizetitle           ;Load title.
	ld      a, %11                  ;Show both title and content text.
	LIB_CALL_(WINLIB,WIN_PSHOW)     ;Prepare & show window.

	ld      b, 3                    ;For the menu you need to load numbers of
	LIB_CALL_(WINLIB,WIN_CHOICE)    ; entrys -1.  Now we call that routine.
	call    c, OTH_EXIT             ; If they press EXIT it sets the carry flag.
					;OTH_EXIT is a call that exits directly to
					; Usgard no matter what is pushed or what
					; calls you are involved in.
	and     a                       ;A holds which entry was picked.  Compare it
	jr      z, bigwin               ; to 0 and see if first entry was picked.
	dec     a                       ;Subtract it and see if number below it is
	jr      z, midwin               ; the entry.
	dec     a                       ;Keep doing this until last entry possible.
	jr      z, smallwin
	call    OTH_EXIT                ;Last entry needs no check since it's last.

bigwin:                                 ;First of the windows.  This one is full 
	ld      bc, $0000               ; screen.
	ld      hl, $1038
	jr      window                  ;Jump to the routine to draw window.
midwin:                                 ;Middle size window sizes.
	ld      bc, $0104
	ld      hl, $0E30
	jr      window
smallwin:                               ;Small window size.
	ld      bc, $0309
	ld      hl, $0A25

window:                                 ;This loads the status byte which only will
	ld      a, %101                 ; display title.
	ld      de, (PROGRAM_ADDR)
	LIB_CALL_(WINLIB,WIN_PSHOW)     ;Prepare and show window.

	ld      bc, $0707               ;Now that setup is done we get to the program.
					;BC is loaded with the birds X/Y pos.
	ld      a, 10                   ;We load the man's X position with 10.
	ld      (manpos), a             ;manpos is the variable for the position.               
R_beg:  call    birddraw                ;Call routine to draw bird to GRAPH_MEM.

loop:                                   ;Now the main loop begins.
	LIB_CALL_(WINLIB,WIN_COPY)      ;This routine copys the GRAPH_MEM -> window.
	ld      hl, (WIN_RSIZE)         ;WIN_RSIZE is the X/Y size of the inside of
					; the window.
	dec     h                       ;Subtract h (x pos) by one because window X
					; pos is screen (X/8) and we need to restrict
					; the bird sprite to the window.
	push    hl                      ;Push the window size.
	ld      l, 8                    ;All we needed was the X position.  We put 8
					; into l to multipy the X/position and 8.
					;That will give us a position for the bird
					; not relative to (X/8)
	call    MUL_HL                  ;This new ROM call is [H*L = HL]
	pop     de                      ;Get old window size in DE.
	ld      d, l                    ;Put l (Y pos) onto d which is the final
	ld      bc, (birdpos)           ; point any sprite can go to.
	call    OTH_ARROW               ;OTH_ARROW allows multi key press.
	ld      h, a                    ;A get's set with the keys that were pressed
	bit     0, h                    ;If bit 0 then the down arrow was pressed.
					;Use R_ to change a CALL_ into a call.
R_dn:   call    z, down                 ;A call is MUCH faster.
	bit     1, h                    ;Bit 1 is left arrow.
R_lt:   call    z, left
	bit     2, h
R_rt:   call    z, right                ;Bit 2 is right arrow.
	bit     3, h
R_up:   call    z, up                   ;Bit 3 is up arrow.
	bit     5, h
R_pp:   call    z, pottyinit            ;Bit 5 is 2nd key which will start the potty
	bit     6, h                    ; routine.
	call    z, OTH_EXIT             ;Bit 6 is the EXIT key.
	push    bc                      ;Save the bird X/Y pos because the next
					; call routine destroys it.
R_lp1:  call    cleargraph              ;Go and clear the GRAPH_MEM off of old sprites.
	pop     bc                      ;Load up BC agian.
R_lp2:  call    birddraw                ;Draw the bird at BC.
R_lp3:  call    manmove                 ;Routine that moves man and draws him.
R_poop: call    poop                    ;Routine that will move and draw poop to the
					; GRAPH_MEM
					;This is what draws the score.
	ld      hl, $3966
	ld      (CURSOR_X), hl
	ld      hl, (score)
	call    DM_HL_DECI              ;Call the function that displays 'a' as a decimal.
	jr      loop                    ;Back to loop.
	     
down:                                   ;These next bunch of loops restrict and move the bird.
	inc     c                       ;Increase its Y position.
	inc     c
	ld      a, e                    ;Restrict the bird from going 16 dots from bottom of
	sub     16                      ; window.  E is the window height.
	cp      c
	ret     nc
	dec     c
	dec     c
	ret
up:
	dec     c
	dec     c
	ld      a, 63                   ;Stop bird from going to top of screen.  If it gets
	cp      c                       ; to 63 (bottom) it has gone too far.
	ret     nc
	inc     c
	inc     c
	ret
left:
	dec     b
	dec     b
	ld      a, 127                  ;Same as before but now to the left.
	cp      b
	ret     nc
	inc     b
	inc     b
	ret
right:
	inc     b
	inc     b
	ld      a, b
	cp      d                       ;Restrict it to the right.
	ret     c
	dec     b
	dec     b
	ret

poop:                                   ;Poop loop.  :-)
	ld      a, (pottycheck)         ;See if the one is dropping.
	and     a                       ;Is the numb in pottycheck zero?
	ret     nz                      ;Return if not.  Means bird is not going.
	ld      bc, (pottypos)          ;He is, so check where it is going.
	ld      a, (WIN_RSIZE)          ;Can't let it leave the screen.  Stop it there.
	cp      c                       ;Check if it hit.
	jr      c, hitground            ;Is it below the ground?  Go to the proper routine.
	sub     7                       ;Subtract 7 and see if it is at the guy's head.
	cp      c                       ;If so see if it is hitting him.
	jr      c, manlevel
pottyback:                              ;If it is neither then drop it some more and save
	inc     c                       ; the position.
	inc     c
	ld      (pottypos), bc
R_py:   ld      hl, pottypic            ;Use R_ to add (PROGRAM_ADDR) to it.
	jr      spritedraw              ;Go and draw the bird.
hitground:                              ;If he hit the ground then put a non-zero number in
	ld      a, $FF                  ; potty check.  Now it won't go through all this
	ld      (pottycheck), a         ; loop.
	ret
manlevel:
	ld      a, (manpos)             ;Is the man's X position equal to the poop?
	cp      b
	jr      z, youwin               ;If so, you win!
	jr      pottyback               ;Otherwise increase the Y position again.

youwin:                                 ;Just do the normal winner stuff.  Display text.
	ld      hl, $0703
	ld      (CURSOR_ROW), hl
R_yw:   ld      hl, wintxt
	call    D_ZT_STR                ;No ROM_CALL.  Easier to remember.  Always 'call'
	call    OTH_PAUSE               ;Function to wait for ENTER
	call    OTH_EXIT                ;Exit no matter what is on the stack or called.
 
birddraw:
R_bd:   ld      hl, bird                ;Load up the bird picture.
	ld      (birdpos), bc           ;Save the bird position.

spritedraw:       
	LIB_CALL_(SPRITLIB,PUTSPRIT)    ;SPRITLIB has Jimmy Merdell's putsprite routine for
	ret                             ; fast drawing of up to 8x8 sprites.

manmove:
	ld      hl, (WIN_RSIZE)         ;This restricts the man movement.  WIN_RSIZE gives
	dec     h                       ; the X/Y size of the inside if window.  Does not
	push    hl                      ; include title bar.
	ld      l, 8
	call    MUL_HL                  ;Since X position is X/8 we multiply the window X
	pop de                          ; size by 8 to be relative to the man/sprite X
	ld      a, e                    ; position.
	sub     8                       ;MUL_HL is H * L = HL
	ld      c, a
	ld      a, (manpos)
fixedman:
	dec     a
	and     a                       ;See if man is at 0.
	jr      z, fixman               ;If so, fix him.
	ld      b, a
	ld      (manpos), a
R_md:   ld      hl, manpic              ;If everything is good then draw him.
	jr      spritedraw
fixman:                                 ;Put him to far right of window.
	ld      a, l
	push    af
	ld      a, (score)
	dec     a                       ;Decrease the score each time he sets back to right
	jr      z, lowscore             ; or window again.
	ld      (score), a
	pop     af
	jr      fixedman

cleargraph:                             ;Clear the GRAPH_MEM so we can put new sprites there.
	ld      hl, GRAPH_MEM           ;OTH_CLEAR will clear starting from HL, BC-1 bytes.
	ld      bc, 1023                ;Just a better way then 'ldir' and loading 0.
	call    OTH_CLEAR
	ret

lowscore:                               ;Is your score Zero?
	ld      hl, $0405
	ld      (CURSOR_ROW), hl
R_ls:   ld      hl, nopoints            ;You are screwed...  :-(
	call    D_ZT_STR                ;call
	call    OTH_PAUSE               ;not ROM_CALL
	call    OTH_EXIT                ;Pause then quit.

pottyinit:
	ld      a, (pottycheck)         ;Start the potting!
	and     a
	ret     z                       ;Don't start if it is already going.
	xor     a
	ld      (pottycheck), a         ;Put zero in pottycheck.
	ld      (pottypos), bc          ;Load the current bird position into the potty pos.
	ld      a, (score)              ;Decrease score every time you potty.
	dec     a
	jr      z, lowscore             ;See if that kills you.
	ld      (score), a
	ret
 
bird:                                   ;Sprites according to PutSprite by JM.
.db 8,5                                 ;X,Y size.
.db %00011000
.db %01011010
.db %10111101
.db %00011000
.db %00100100

manpic:
.db 8,8
.db %01011100
.db %01011000
.db %00111100
.db %00011010
.db %00011010
.db %01110100
.db %01000010
.db %11000011

pottypic:
.db 5,4
.db %00100
.db %01110
.db %01110
.db %01110



begintxt:
.db LF,TAB,"Austin Butler",LF                   ;This is how you manage window text.
.db TAB,"@u$+!N prgms",LF,LF                    ;LF = Line Feed.  Go to next line.
.db "Choose window size",0                      ;TAB is like a computer tab.

sizetitle:
.db "Size",0                                    ;Title text does not use those things.
sizetxt:
.db "Full",LF                                   ;Go from line to line.
.db "Mid",LF
.db "Small",LF
.db "Exit",0
wintxt:
.db "You Win!!",0
nopoints:
.db "Out of points!",0

.end                                            ;Good luck programming for Usard!!!

;Austin Butler
;@u$+!N prgms
;corndog@flash.net      Mail me if you have any questions on this source.
